/*
 * Derived by the MIT X11R5 Mailbox widget which is
 * Copyright 1988 Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * Original Mailbox widget Author:  Jim Fulton, MIT X Consortium
 *
 * Mailbox++ XPM additions-modifications: Dimitrios P. Bouras
 *           audio support: William K. W. Cheung
 */

#ifndef _Mailbox_XPM_P_h
#define _Mailbox_XPM_P_h

#include "Mailbox++.h"
#include <X11/Xaw/SimpleP.h>
#include <xpm.h>

#ifdef SYSV
#define MAILBOX_DIRECTORY "/usr/mail"
#else
#ifdef SVR4
#define MAILBOX_DIRECTORY "/var/mail"
#else
#define MAILBOX_DIRECTORY "/usr/spool/mail"
#endif
#endif

typedef struct {			/* new fields for mailbox widget */
    /* resources */
    int update;				/* seconds between updates */
    String filename;			/* filename to watch */
    String check_command;		/* command to exec for mail check */
    int volume;				/* bell volume */
    Boolean once_only;			/* ring bell only once on new mail */
    String mail_tool;			/* mail app when mail in above file */
    String mail_xpmfile;		/* xpm icon when mail in above file */
    String mail_sndfile;		/* xpm sound when mail in above file */
    String nomail_xpmfile;		/* and for the case of no mail */
    
    /* local state */
    GC gc;				/* normal GC to use */
    long last_size;			/* size in bytes of mailboxname */
    XtIntervalId interval_id;		/* time between checks */
    Boolean flag_up;			/* is the flag up? */
    struct _mbimage {
	Pixmap bitmap;			/* depth 1, describing shape */
	Pixmap pixmap;			/* full depth pixmap */
	XpmImage *xpmimg;		/* the xpm image */
	int width, height;		/* geometry of pixmaps */
    } full, empty;
    struct {
	Pixmap mask;
	int x, y;
    } shape_cache;			/* last set of info */
} Mailbox_XPM_Part;

typedef struct _Mailbox_XPM_Rec {	/* full instance record */
    CorePart core;
    SimplePart simple;
    Mailbox_XPM_Part mailbox;
} Mailbox_XPM_Rec;


typedef struct {			/* new fields for mailbox class */
    int dummy;				/* stupid C compiler */
} Mailbox_XPM_ClassPart;

typedef struct _Mailbox_XPM_ClassRec {	/* full class record declaration */
    CoreClassPart core_class;
    SimpleClassPart simple_class;
    Mailbox_XPM_ClassPart mailbox_class;
} Mailbox_XPM_ClassRec;

extern Mailbox_XPM_ClassRec mailboxClassRec;	 /* class pointer */

#endif /* _Mailbox_XPM_P_h */
